#include <stdlib.h>
#include <stdio.h>
#include "../SimionPA/SimionPA.h"
#include <errno.h>
#include <string.h>

void display_grid(PAHeader head, double ***g){
        int y = 0;
        int x = 0;
	int z = 0;
	
        printf("-----------------------------------\n");
        for (z=0; z < head.nz; z++) {
		printf("{\n");
		for (y=0; y < head.ny; y++) {
			printf("\t{");
        	        for (x=0; x<head.nx; x++) {
				char suf[2];
				if (!(x == (head.nx - 1))) {
					strcpy(suf,",");
				}else{
					strcpy(suf,"");
				}
				
				if (g[z][y][x] >= head.max_voltage) {
					printf("%+2.3lf%s", g[z][y][x] - 2 * head.max_voltage , suf);
				} else {
					printf("%+2.3lf%s", g[z][y][x], suf);
				}
				
	                }
			if (y == (head.ny - 1)){
				printf("}\n");
				continue;
			}
        	        printf("},\n");
	        }
		if (z == (head.nz - 1)){
			printf("}\n");
			continue;
		}
		printf("},\n");
	}
        printf("-----------------------------------\n");
}

int main(int argc, char *argv[]){
	if (argc != 2) {
		fprintf(stderr, "Usage: %s filename\n", argv[0]);
		return EXIT_FAILURE;
	}
	PAHeader pa_head;
	double ***points = NULL;
	if ((points = load_pa_file(argv[1], &pa_head, points))==NULL) {
		perror("Main - load_pa_file returned error");
		return EXIT_FAILURE;
	}
	display_grid(pa_head, points);
	free_points(pa_head, points);
	#ifdef DEBUG
	perror("");
	#endif
	return errno;
}
