# generate.py
# Based on swirl.py, provided in the SIMION examples

from SIMION.PA import *
from math import *


# create new potential array
pa = PA(nx=830, ny=125, nz=1)
pa.mirror('y')
pa.symmetry('cylindrical')

# iterate over all points
for x in range(0, pa.nx()):
    for y in range(0, pa.ny()):
        # compute point value
        is_electrode1 = ((((x >= 3 and x <= 5) or (x >= 817 and x <=819)) and y <= 123) or ( (y >= 121 and y <= 123) and ((x >= 3 and x <= 294) or (x >= 528 and x <= 820))))
        is_electrode2 = (((x >= 294 and x <= 392) or (x >= 430 and x <= 528)) and (y >= 121 and y <= 123))
	is_electrode3 = ((x >= 392 and x <= 430) and (y >= 121 and y<= 123))
        # set point value
        if is_electrode1: pa.point(x, y, 0, 1, 0)
	if is_electrode2: pa.point(x, y, 0, 1, 88.1)
	if is_electrode3: pa.point(x, y, 0, 1, 100)

# write file
pa.save("5-electrode.pa")
