# generate.py

from SIMION.PA import *
from math import *


# create new potential array
pa = PA(nx=90, ny=25, nz=25)

delta = 3 #Wall thickness
R=12
r=R-delta
L1=82
L2=23
L3=4

offset1=(pa.nx()-L1)/2
offset2=(pa.nx()-L2)/2
offset3=(pa.nx()-L3)/2

centreZ=pa.nz()/2
centreY=pa.ny()/2

V1 = 0
V2 = 88.1
V3 = 100

# iterate over all points
for x in range(0, pa.nx()):
    for y in range(0, pa.ny()):
        for z in range(0,pa.nz()):
            # compute point value
            radius=sqrt(pow(z-centreZ,2)+pow(y-centreY,2))
            if (offset3 <= x < (offset3 + L3)) and (r <= radius < R):
                pa.point(x, y, z, 1, V3)
            elif (offset2 <= x < (offset2 + L2)) and (r <= radius < R):
                #Set Central Electrode Potential
                pa.point(x, y, z, 1, V2)
            elif ((offset1 <= x < offset2) or ((offset2 + L2) <= x < (offset1 + L1))) and (r <= radius < R):
                #Set Outer Electrode potential (cap wall)
                pa.point(x, y, z, 1, V1)
            elif ((offset1 <= x < (offset1 + delta)) or ((offset1 + L1 - delta) <= x < (offset1 + L1))) and (radius <= r):
                #Set Outer Electrode potential (cap face)
                pa.point(x, y, z, 1, V1)


# write file
pa.save("5-electrode3D.pa")
