# generate.py
# Based on swirl.py, provided in the SIMION examples

from SIMION.PA import *
from math import *


# create new potential array
pa = PA(nx=100, ny=100, nz=300)

delta = 10 #Wall thickness
R=40
r=R-delta
L1=280
L2=50
offset1=(pa.nz()-L1)/2
offset2=(pa.nz()-L2)/2

centreX=pa.nx()/2
centreY=pa.ny()/2

# iterate over all points
for x in range(0, pa.nx()):
    for y in range(0, pa.ny()):
        for z in range(0,pa.nz()):
            # compute point value
            radius=sqrt(pow(x-centreX,2)+pow(y-centreY,2))
            if (offset2 <= z < (offset2 + L2)) and (r <= radius < R):
                #Set Central Electrode Potential
                pa.point(x, y, z, 1, 100)
            elif ((offset1 <= z < offset2) or ((offset2 + L2) <= z < (offset1 + L1))) and (r <= radius < R):
                #Set Outer Electrode potential (cap wall)
                pa.point(x, y, z, 1, 0)
            elif ((offset1 <= z < (offset1 + delta)) or ((offset1 + L1 - delta) <= z < (offset1 + L1))) and (radius <= r):
                #Set Outer Electrode potential (cap face)
                pa.point(x, y, z, 1, 0)
# write file
pa.save("Big3DCylinder.pa")
